﻿#define F_CPU 16000000UL  // toto je lepsie vlozit do parametrov pre kompilator

#include <avr/io.h>
#include <util/delay.h>

#define O0 50000000000		// toto neexistuje teda nehra nic
// melodia:
#define C4 118
#define D4 106
#define E4 94
#define G4 79
#define A4 70
#define H4 62
#define C5 59
#define D5 52
#define E5 46
#define F5 44
#define G5 39

// bass:
#define A3 141
#define G3 158
#define F3 178
#define E3 189
#define D3 213
#define C3 238
#define H2 252


void InitTimer0(){
  DDRD   |= (1 << PD6);            // port D.6 pin ako vystup
  
  TCCR0A = 0b01000010;
  TCCR0B = 0b00000100;
  
  OCR0A = 70;
  
}

void InitTimer1(){
	DDRB   |= (1 << PB1);            // port D.9 pin ako vystup
  
	TCCR1A = 0b01000000;
	TCCR1B = 0b00001100;			// preddelicka 256
	
	OCR1A = 70;
  
}

void InitTimer2(){
 DDRB   |= (1 << PB3);            // port D.11 pin ako vystup
  
  TCCR2A = 0b01000010;
  TCCR2B = 0b00000110;
  
  OCR2A = 70;
  
}

void speaker0(vyska_tonu0){
	OCR0A = vyska_tonu0;
}

void speaker1(vyska_tonu1){
	OCR1A = vyska_tonu1;
	TCNT1 = 0x00;					// resetovanie pocitadla T1 aby nesekalo
}

void speaker2(vyska_tonu2){
	OCR2A = vyska_tonu2;
}

void delay(int delay)   // vlastna funkcia, lebo inak je max 16ms
{
	for (int i=1; i <= delay - 2; i++){
		_delay_ms(1);
	}

	OCR0A = O0;						// malinka pauza za kazkou notou melodie 
    for (int i=1; i <= 2; i++){		// ... ked za sebou idu dve rovnake noty aby nezneli
	  _delay_ms(1);					// ako jedna spojita
	}
}

int main(void)
{	
	InitTimer0();
	InitTimer1();
	InitTimer2();

	int tempo = 250;
		
	while(1){
		//	------------------------ Happy birthday ------------------------ //
		
		// 1 takt
		speaker0(G4);	speaker1(O0); speaker2(O0);			delay(tempo);			// ha-
		speaker0(G4);										delay(tempo);			// -ppy
		speaker0(A4);	speaker1(G3); speaker2(C3);			delay(tempo*2);			// Birth-
		speaker0(G4);										delay(tempo*2);			// -day
		
		// 2 takt
		speaker0(C5);	speaker1(O0); speaker2(O0);			delay(tempo*2);			// to
		speaker0(H4);	speaker1(G3); speaker2(H2);			delay(tempo*4);			// you
	
		// 3 takt
		speaker0(G4);	speaker1(O0); speaker2(O0);			delay(tempo);			// ha-
		speaker0(G4);										delay(tempo);			// -ppy
		speaker0(A4);	speaker1(G3); speaker2(H2);			delay(tempo*2);			// Birth-
		speaker0(G4);										delay(tempo*2);			// -day
		
		// 4 takt
		speaker0(D5);	speaker1(O0); speaker2(O0);			delay(tempo*2);			// to
		speaker0(C5);	speaker1(G3); speaker2(C3);			delay(tempo*4);			// you
		
		 // 5 takt
		speaker0(G4);	speaker1(O0); speaker2(O0);			delay(tempo);			// ha-
		speaker0(G4);										delay(tempo);			// -ppy
		speaker0(G5);	speaker1(C4); speaker2(E3);			delay(tempo*2);			// Birth-
		speaker0(E5);										delay(tempo*2);			// -day
		
		// 6 takt
		speaker0(C5);	speaker1(O0); speaker2(O0);			delay(tempo*2);			// dear
		speaker0(H4);	speaker1(C4); speaker2(F3);			delay(tempo*2);			// Ji-
		speaker0(A4);										delay(tempo*2);			// -mmy
		
		// 7 takt
		speaker0(F5);	speaker1(O0); speaker2(O0);			delay(tempo);			// Ha-
		speaker0(F5);										delay(tempo);			// -ppy
		speaker0(E5);	speaker1(C4); speaker2(E3);			delay(tempo*2);			// birth-
		speaker0(C5);										delay(tempo*2);			// -day
		
		// 8 takt
		speaker0(D5);	speaker1(G3); speaker2(D3);			delay(tempo*2);			// to
		speaker0(C5);	speaker1(G3); speaker2(C3);			delay(tempo*4);			// you
		
	}


}	